#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "taclist.h"

using namespace std;

//------------------------------------------------------------
TaCList::~TaCList() {
   list<TeaAndCoffee*>::iterator vi;
   for (vi = tacList.begin();  vi != tacList.end();  vi++)
       delete (*vi);            // delete TeaAndCoffee objektus
       tacList.clear();         // delete TeaAndCoffee nuorodas (pointers)
}
//------------------------------------------------------------
void TaCList::printList() {
   cout << "* * * * * * * * * * * * * * * * * * * * * * * * * *" << endl;
   tacList.sort(Palyginti1());
   list<TeaAndCoffee*>::iterator vi = tacList.begin();
   for (;  vi != tacList.end();  vi++)
      (*vi)->printType();
   cout << "* * * * * * * * * * * * * * * * * * * * * * * * * *" << endl;
}
//------------------------------------------------------------
void TaCList::printFullProfit() {
   tacList.sort(Palyginti1());
   list<TeaAndCoffee*>::iterator vi = tacList.begin();
   for (;  vi != tacList.end();  vi++)
      (*vi)->printProfit();
}
//------------------------------------------------------------
void TaCList::toList(std::string title, std::string name, int how, float price, std::string date) {
  list<TeaAndCoffee*>::iterator i=tacList.begin();
  while((i!=tacList.end())&&((*i)->getType()!=title))
    i++;
  if(i==tacList.end()) {
    TeaAndCoffee* g=new TeaAndCoffee(title);
    g->toList(name, how, price, date);
    tacList.push_back(g);
  }
  else
    (*i)->toList(name, how, price, date);
}
//------------------------------------------------------------
void TaCList::sellingNew() {
   string title;
   int how;
   float price;
   std::string date;
   cout << "Kokiai RUSIAI priskirti pardavima: ";
   cin >> title;
   cout << "Kiekis: ";
   cin >> how;
   cout << "Pakelio kaina: ";
   cin >> price;
   cout << "Pardavimo data (MMMM-mm-dd): ";
   cin >> date;
   list<TeaAndCoffee*>::iterator iter = tacList.begin();
      for (;  iter != tacList.end();  iter++) {
         string grupeX = (*iter)->getType();
         if (grupeX == title) {
            (*iter)->toList("parduota", how, price, date);
            break;
         }
      }
}
//------------------------------------------------------------
void TaCList::buyingNew() {
   string title;
   int how;
   float price;
   std::string date;
   cout << "Kokiai RUSIAI priskirti pirkima: ";
   cin >> title;
   cout << "Kiekis: ";
   cin >> how;
   cout << "Pakelio kaina: ";
   cin >> price;
   cout << "Pardavimo data (MMMM-mm-dd): ";
   cin >> date;
   list<TeaAndCoffee*>::iterator iter = tacList.begin();
      for (;  iter != tacList.end();  iter++) {
         string grupeX = (*iter)->getType();
         if (grupeX == title) {
            (*iter)->toList("nupirkta", how, -price, date);
            break;
         }
      }
}
//------------------------------------------------------------
void TaCList::createNewType() {
   string title;
   cout << "Kaip vadinsis nauja RUSIS : ";
   cin >> title;
   tacList.push_back(new TeaAndCoffee(title));
}
//------------------------------------------------------------
void TaCList::printTaCPeriod() {
   string dataNuo;
   string dataIki;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<TeaAndCoffee*>::iterator iter = tacList.begin();
   for (;  iter != tacList.end();  iter++)
      (*iter)->printPeriod(dataNuo, dataIki);
}
//------------------------------------------------------------
void TaCList::printOneProfit() {
   string title;
   cout << "Kokios RUSIES spausdinti apyvarta: ";
   cin >> title;
   list<TeaAndCoffee*>::iterator iter = tacList.begin();
   for (;  iter != tacList.end();  iter++) {
      string grupeX = (*iter)->getType();
      if (grupeX == title)
         (*iter)->printType();
   }
}
//------------------------------------------------------------
void TaCList::toFile() {
   ofstream outFile("output.txt");
   tacList.sort(Palyginti1());
   list<TeaAndCoffee*>::iterator vi = tacList.begin();
   for (;  vi != tacList.end();  vi++)
      (*vi)->saveToFile(outFile);
   outFile.close();
}
//------------------------------------------------------------
