#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "teaandcoffee.h"

using namespace std;

//------------------------------------------------------------
TeaAndCoffee::TeaAndCoffee(std::string title) {
  this->title=title;
}
//------------------------------------------------------------
TeaAndCoffee::~TeaAndCoffee() {
  list<Sort*>::iterator i;
   for (i = sortlist.begin();  i != sortlist.end();  i++)
       delete (*i);
       sortlist.clear();
}
//------------------------------------------------------------
string TeaAndCoffee::getType() {
  return(title);
}
//------------------------------------------------------------
void TeaAndCoffee::printType() {
  cout<<title<<":"<<endl;
  list<Sort*>::iterator i=sortlist.begin();
  for(; i!=sortlist.end(); i++)
     cout<<"   "<<(*i)->getDate()<<" : "<<(*i)->getName()<<", "<<(*i)->getHow()<<" x "<<(*i)->getPrice()<<"Lt = "<<(*i)->getSortProfit()<<"Lt."<<endl;
  cout<<endl;
}
//------------------------------------------------------------
void TeaAndCoffee::printProfit() {
  float profit=0;
  cout<<title<<": ";
  list<Sort*>::iterator i=sortlist.begin();
  for(; i!=sortlist.end(); i++)
     profit+=(*i)->getSortProfit();
  cout<<profit<<"Lt."<<endl;
}
//------------------------------------------------------------
void TeaAndCoffee::printPeriod(std::string nuo, std::string iki) {
  float profit=0;
  cout<<endl;
  cout<<title<<": ";
  list<Sort*>::iterator i=sortlist.begin();
  for(; i!=sortlist.end(); i++)
     if((nuo <= (*i)->getDate()) && ((*i)->getDate() <= iki))
        profit+=(*i)->getSortProfit();
  cout<<profit<<"Lt."<<endl;
  cout<<endl;
}
//------------------------------------------------------------
void TeaAndCoffee::toList(std::string name, int how, float price, std::string date) {
  sortlist.push_back(new Sort(name, how, price, date));
}
//------------------------------------------------------------
void TeaAndCoffee::saveToFile(std::ofstream& outFile) {
   outFile<<title<<":"<<endl;
   list<Sort*>::iterator i=sortlist.begin();
   for(; i!=sortlist.end(); i++)
     outFile<<"   "<<(*i)->getDate()<<" : "<<(*i)->getName()<<", "<<(*i)->getHow()<<" x "<<(*i)->getPrice()<<"Lt = "<<(*i)->getSortProfit()<<"Lt."<<endl;
}
//------------------------------------------------------------
